// Программа "Diskret". Моделирование процесса дискретизации
// аналогового сигнала и восстановления аналогового сигнала
// из дискретного
//
// Ввод исходных данных для моделирования
//
X1=1;  //Амплитуда первой гармоники
X2=0.9; //Амплитуда второй гармоники
X3=0.5; //Амплитуда третьей гармоники
phi1=0;  //Начальная фаза первой гармоники
phi2=0; //Начальная фаза второй гармоники
phi3=0; //Начальная фаза третьей гармоники
F1=1 // Частота  первой гармоники сигнала
Fd=4 // Частота дискретизации
delta_t=1/512; //Временной интервал между двумя соседними
                      //расчетными точками
//
// Расчет вспомогательных параметров
is=ceil(1/(F1*delta_t)); //Количество расчетных точек в периоде сигнала
id=ceil(1/(Fd*delta_t)); //Количество расчетных точек в интервале
                                  // дискретизации
imax=64*is;  // Количество расчетных точек
I=6*is; // Количество расчетных точек на графике
//
//Начальная установка (обнуление массивов)
i=zeros(1:imax);
x=zeros(1:imax);
u=zeros(1:imax);
xd=zeros(1:imax);
xv=zeros(1:imax);
s=zeros(1:imax);
sd=zeros(1:imax);
sv=zeros(1:imax);
i0=zeros(1:I);
x0=zeros(1:I);
u0=zeros(1:I);
xd0=zeros(1:I);
xv0=zeros(1:I);
t=zeros(1:I);
u=zeros(1:imax)
z=0
//
// Формирование аналогового сигнала
//
for i=1:imax
   x1=X1*cos(2*%pi*F1*delta_t*i+phi1);
   x2=X2*cos(4*%pi*F1*delta_t*i+phi2);
   x3=X3*cos(6*%pi*F1*delta_t*i+phi3);
   x(i)=x1+x2+x3;
//
// Формирование последовательности единичных отсчетов
//
   z=z+1
   if z = = id then z=0
   end
   if z= = 0 then u(i)=1
       else    u(i)=0
   end
//
// Дискретизация аналогового сигнала
xd(i)=x(i)*u(i);
end
// Формирование массивов данных для построения графиков
for i0=1:I
  x0(i0)=x(i0);
  u0(i0)=u(i0);
  xd0(i0)=xd(i0);
  end
i0=[1:I];
t=delta_t*i0;
clf()// Очистка графического окна перед выдачей графиков
subplot(3,2,1);
xtitle('Аналоговый сигнал на входе дискретизатора')
plot(t,x0,"b")
xgrid
subplot(3,2,5);
xtitle('Последовательность  единичных отсчетов')
plot2d3(t,u0)
subplot(3,2,2);
xtitle('Дискретный сигнал')
plot2d3(t,xd0,style=[color("red")])
xgrid
//
//Определение спектра аналогового и дискретного сигнала
//
s=fft(x);
sd=fft(xd);
kmax=30*floor(imax/is);
k=zeros(1:kmax);
f=zeros(1:kmax);
s0=zeros(1:kmax);
sd0=zeros(1:kmax);
k=[1:kmax];
f=k/(delta_t*imax);
for k=1:kmax
  s0(k)=s(k)*2/imax;
  sd0(k)=sd(k)*2/imax;
  end
subplot(3,2,3)
xtitle('Спектр аналогового сигнала')
plot2d3(f,abs(s0),style=[color("blue")])
xgrid
subplot(3,2,4)
xtitle('Спектр дискретного сигнала')
plot2d3(f,abs(sd0),style=[color("red")])
xgrid
//
// Восстановление аналогового сигнала из дискретного
//
k1=floor(0.5*imax/id);// Номер отсчета спектра,
// соответствующий половине частоты дискретизации
for k=1:imax
  if k<k1 then
  sv(k)=sd(k);
else
  sv(k)=0;
  end
end
// Формирование восстановленного сигнала
xv=ifft(sv);
for i0=1:I
  xv0(i0)=xv(i0);
  end
subplot(3,2,6)
xtitle('Восстановленный аналоговый сигнал')
plot2d(t,xv0,style=[color("green")])
xgrid

