    //Программа синтеза нерекурсивного цифрового гауссовского ФНЧ 
    //
    //Ввод исходных данных
    K0=5  //Половина длины линии задержки
    fNg=0.05  //Нормированная граничная частота фильтра
    sigma=sqrt(2)  //Неравномерность АЧХ в полосе 
    delta_m=-60  //Максимальный уровень пульсаций в дБ
    // Функция, описывающая требуемую АЧХ фильтра в интервале 
    // нормированных частот от 0 до 0.5
    function u=K(fN), u=exp(-log(sigma)*(fN/fNg)^2)
     endfunction;
    // Функция, описывающая требуемую АЧХ фильтра в интервале  
    // нормированных частот от 0 до 0.5, заданную в дБ  
      function ul=KdB(fN),
          if K(fN)>10^-10 then ul=20*log10(K(fN))
              else ul=-200
          end
      endfunction
    delta_f=0.0001 //Шаг изменения частоты при расчете АЧХ и ФЧХ  
    I=ceil(0.5/delta_f)// Количество расчетных точек АЧХ на графиках
    i=[1:I+1] // Массив номеров расчетных точек
    fN=(i-1)*delta_f // Массив значений частот при расчете АЧХ
    y=zeros(1:I+1); // Обнуление массивов y и y1
    y1=zeros(1:I+1);
    for i=1:I+1     // Формирование массивов  значений АЧХ в расчетных
                         // точках  
        y(i)=K(delta_f*(i-1))
        yl(i)=KdB(delta_f*(i-1))
    end;
    clf()// Очистка графического окна перед выдачей графиков
    // Построение графика требуемой АЧХ в относительном масштабе
    subplot(221)
    xtitle("Требуемая АЧХ фильтра", "fN","K( fN )" )
    plot(fN,y,"k")
    xgrid(3)
    // Построение графика требуемой АЧХ в дБ
    subplot(222)
    xtitle("Требуемая АЧХ фильтра в дБ", "f N","K l ( f N )) dB" )
    plot(fN,yl,"k")
    xgrid(3)
    //Формирование массива коэффициентов системной функции фильтра
    b0=2*intg(0,0.5,K)// Расчет коэффициента b0
    b=zeros(1:K0)
    function    w=KC(fN,k),     w=2*K(fN)*cos(2*%pi*k*fN),
    endfunction
    for k=1:K0
        b(k)=intg(0,0.5,KC)
    end
    //Системная функция цифрового фильтра
    function v=H(z)
    v=b0
    for k=1:K0
        v=v+b(k)*(z^k+z^-k)
    end
    v=v*z^-K0
    endfunction
    //Расчет зависимости комплексного коэффициента передачи фильтра 
    // от частоты, АЧХ и ФЧХ
    Kk=zeros(1:I+1)
    for i=1:I+1
        z=%e^(%i*2*%pi*delta_f*(i-1))
        Kk=H(z) // Комплексный коэффициент передачи
         if abs(Kk)>10^-10 then K0dB(i)=20*log10(abs(Kk))// АЧХ
         else K0dB(i)=-200
         end    
         fi(i)=atand(imag(Kk),real(Kk))  // ФЧХ 
    end
    // График АЧХ
    subplot(223)
    xtitle("Рассчитанная АЧХ фильтра в дБ", "f N","K 0 dB ( f N )" )
    plot(fN,K0dB,"k")
    xgrid(3)
    //График ФЧХ
    subplot(224)
    xtitle("ФЧХ фильтра в градусах", "f N","Angle ( f N ) в градусах" )
    plot(fN,fi,"k")
    xgrid(3)
    // Выдача на дисплей значений коэффициентов системной функции
    disp(b0)
    disp(b)