// Программа моделироания цифрового ФНЧ при действии на его входе 
// сигнала и помехи
// Ввод исходных данных
// Параметры фильтра
K0=8 // Половина длины линии задержки фильтра 
fNg=0.05 //Нормированная граничная частота фильтра 
sigma=sqrt(2) // Неравномерность АЧХ в полосе пропускания   
sigma_m=-60  //Максимальный уровень пульсаций в дБ
// Параметры сигнала
n0=20  // Количество отсчетов в элементарной посылке
       // передаваемого первичного сигнала
// Параметры помехи
Xp=2 // Амплитуда помехи
fNp=0.2      
nmax=10*n0 // Максимальный номер отсчета  
// Функция, описывающая требуемую АЧХ фильтра в интервале 
// нормированных частот от 0 до 0.5
function u=K(fN), u=exp(-log(sigma)*(fN/fNg)^2)
 endfunction;
  b0=2*intg(0,0.5,K) // Расчет коэффициента B0 
  function    w=KC(fN,k),     w=2*K(fN)*cos(2*%pi*k*fN),
endfunction
b=zeros(1:K0)
for k=1:K0
b(k)=intg(0,0.5,KC)
end
clf()
z=0
u=0
xc=zeros(1:nmax)
x0=zeros(1:nmax)
y=zeros(1:nmax)
x=zeros(1:2*K0)  
  for n=1:nmax
      //Формирование сигнала 
      z=z+1
      if z==n0 then z=0
      end
      if z==0 then
          if rand(1)< 0.5 then u =-1
              else u =1
          end
      end
      xc(n)=u
      // Формирование синусоидальной помехи
      xp=Xp*sin(2*%pi*fNp*n)
      // Сигнал и помеха на входефильтра
      x0(n)=xc(n)+xp
          //subplot(311)
          //xtitle("Сигнал на входе фильтра", "n","x c" )
          //plot2d3(n,xc)
          //subplot(312)
          //xtitle("Сигнал с помехой на входе фильтра", "n","x 0" )
          //plot2d3(n,x0)
          y(n)=b0*x(K0)
          for k=1:K0-1
          y(n)=y(n)+b(k)*(x(K0-k)+x(K0+k)) 
          end
           y(n)=y(n)+b(K0)*(x0(n)+x(2*K0)) 
          //subplot(313) 
          //xtitle("Сигнал на выходе фильтра", "n","y" )  
          //plot2d3(n,y)
          for k=1:2*K0-1
          x(2*K0+1-k)=x(2*K0-k)
          end 
          x(1) =x0(n)       
  end
  n=1:nmax
  subplot(311)
          xtitle("Сигнал на входе фильтра", "n","x c" )
          plot(n,xc)
          xgrid(3)
          subplot(312)
          xtitle("Сигнал с помехой на входе фильтра", "n","x 0" )
          plot(n,x0)
          xgrid(3)
          subplot(313) 
          xtitle("Сигнал на выходе фильтра", "n","y" )  
          plot(n,y)
          xgrid(3)